#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirer_1 = __importDefault(require("inquirer"));
const shelljs_1 = __importDefault(require("shelljs"));
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const banners = __importStar(require("../utils/banners"));
const index_1 = require("../src/index");
(function () {
    return __awaiter(this, void 0, void 0, function* () {
        console.log();
        console.log(process.stdout.isTTY && process.stdout.getColorDepth() > 8
            ? banners.gradientBanner
            : banners.defaultBanner);
        console.log();
        const answers = yield inquirer_1.default.prompt([
            {
                type: 'input',
                message: 'Name of your app:',
                name: 'name',
                default: 'host',
            },
            {
                type: 'list',
                message: 'Project Type:',
                name: 'type',
                choices: ['Application', 'StoryBook', 'Packages', 'SingleSpa', 'Flutter'],
                default: 'Application',
            },
        ]);
        if (answers.type === 'Packages') {
            (0, index_1.buildProject)(answers);
        }
        if (answers.type === 'Flutter') {
            const serverAnswers = yield inquirer_1.default.prompt([
                {
                    type: 'input',
                    message: 'Port number:',
                    name: 'port',
                    default: '9001',
                },
            ]);
            (0, index_1.buildProject)(Object.assign(Object.assign({}, answers), serverAnswers));
        }
        if (answers.type === 'StoryBook') {
            const templates = fs_1.default
                .readdirSync(path_1.default.join(__dirname, '../templates/storybook'))
                .sort();
            const storyAnswers = yield inquirer_1.default.prompt([
                {
                    type: 'input',
                    message: 'Port number:',
                    name: 'port',
                    default: '6006',
                },
                {
                    type: 'list',
                    message: 'Framework:',
                    name: 'framework',
                    choices: templates,
                    default: 'react',
                },
            ]);
            const lang = storyAnswers.framework === 'vue3' ? ['javascript'] : ['typescript', 'javascript'];
            const storyAnswersLang = yield inquirer_1.default.prompt([
                {
                    type: 'list',
                    message: 'Language:',
                    name: 'language',
                    choices: lang,
                    default: 'javascript',
                },
            ]);
            (0, index_1.buildProject)(Object.assign(Object.assign(Object.assign({}, answers), storyAnswers), storyAnswersLang));
        }
        if (answers.type === 'SingleSpa') {
            const templates = fs_1.default
                .readdirSync(path_1.default.join(__dirname, '../templates/singlespa'))
                .sort();
            const appAnswers = yield inquirer_1.default.prompt([
                {
                    type: 'list',
                    message: 'Framework:',
                    name: 'framework',
                    choices: templates,
                    default: 'react',
                }
            ]);
            (0, index_1.buildProject)(Object.assign(Object.assign({}, answers), appAnswers));
        }
        if (answers.type === 'Application') {
            const tools = fs_1.default
                .readdirSync(path_1.default.join(__dirname, `../templates/application`))
                .sort();
            const appAnswersTools = yield inquirer_1.default.prompt([
                {
                    type: 'input',
                    message: 'Port number:',
                    name: 'port',
                    default: '9001',
                },
                {
                    type: 'list',
                    message: 'Tools build:',
                    name: 'toolsbuild',
                    choices: tools,
                    default: 'Webpack5',
                },
            ]);
            const templates = fs_1.default
                .readdirSync(path_1.default.join(__dirname, `../templates/application/${appAnswersTools.toolsbuild}`))
                .sort();
            const appAnswersTemplate = yield inquirer_1.default.prompt([
                {
                    type: 'list',
                    message: 'Type:',
                    name: 'typeweb',
                    choices: templates,
                    default: 'SPA',
                },
            ]);
            const typeweb = fs_1.default
                .readdirSync(path_1.default.join(__dirname, `../templates/application//${appAnswersTools.toolsbuild}/${appAnswersTemplate.typeweb}`))
                .sort();
            const appAnswersType = yield inquirer_1.default.prompt([
                {
                    type: 'list',
                    message: 'Framework:',
                    name: 'framework',
                    choices: typeweb,
                    default: 'react',
                },
            ]);
            const lang = (appAnswersTools.toolsbuild === 'Vite' && appAnswersType.framework === 'react' || appAnswersType.framework === 'angular') ? ['typescript'] : ['typescript', 'javascript'];
            const appAnswersList = yield inquirer_1.default.prompt([
                {
                    type: 'list',
                    message: 'Language:',
                    name: 'language',
                    choices: lang,
                    default: 'javascript',
                },
                {
                    type: 'list',
                    message: 'CSS:',
                    name: 'css',
                    choices: ['CSS', 'Tailwind', 'Bootsrap'],
                    default: 'CSS',
                },
            ]);
            (0, index_1.buildProject)(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, answers), appAnswersTools), appAnswersTemplate), appAnswersType), appAnswersList));
        }
        shelljs_1.default.echo(`Your '${answers.name}' project. 🔥 READY 🔥.

Next steps:

▶️ cd ${answers.name}
▶️ yarn
▶️ yarn start
`);
    });
})();
